package cd.casic.ci.commons.bean.process.setting;


import cd.casic.module.system.api.user.dto.AdminUserRespDTO;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

/**
 * @author by mianbin
 * @Classname Test
 * @Description 流水线主机认证模型
 * @Date 2025/4/22 8:45
 */
@Data
@Builder
@Accessors(chain = true)
@NoArgsConstructor
@AllArgsConstructor
public class AuthHostK8s {

    /**
     * @pi.name:hostId
     * @pi.dataType:string
     * @pi.desc:id
     * @pi.value:hostId
     */
    private String hostId;

    /**
     * @pi.name:type
     * @pi.dataType:string
     * @pi.desc:类型 common 普通  aliyun  阿里云； tencent. 腾讯云
     * @pi.value:aliyun
     */
    private String type;

    /**
     * @pi.name:authType
     * @pi.dataType:Integer
     * @pi.desc:认证类型 1.用户名密码 2. 通用认证
     * @pi.value: 1
     */
    private Integer authType;

    /**
     * @pi.name:name
     * @pi.dataType:string
     * @pi.desc:名称
     * @pi.value:name
     */
    private String name;

    /**
     * @pi.name:ip
     * @pi.dataType:string
     * @pi.desc:ip地址
     * @pi.value:ip
     */
    private String ip;

    /**
     * @pi.name:port
     * @pi.dataType:Integer
     * @pi.desc:端口号
     * @pi.value:8080
     */
    private Integer port;

    /**
     * @pi.name:createTime
     * @pi.dataType:string
     * @pi.desc:创建时间
     * @pi.value:createTime
     */
    private String createTime;

    /**
     * @pi.name:username
     * @pi.dataType:string
     * @pi.desc:用户名
     * @pi.value:username
     */
    private String username;

    /**
     * @pi.name:password
     * @pi.dataType:string
     * @pi.desc:密码
     * @pi.value:password
     */
    private String password;

    /**
     * @pi.name:privateKey
     * @pi.dataType:string
     * @pi.desc:私钥
     * @pi.value:privateKey
     */
    private String privateKey;

    /**
     * @pi.model:user
     * @pi.desc:创建人
     */
    private AdminUserRespDTO adminUserRespDTO;

    /**
     * @pi.name:authPublic
     * @pi.dataType:Integer
     * @pi.desc:是否公开 1.公开 3.不公开
     * @pi.value:1
     */
    private int authPublic;
}
