package cd.casic.module.process.support.util.impl;

import cd.casic.ci.commons.bean.process.definition.Pipeline;
import cd.casic.module.process.message.message.MessageDmNoticeService;
import cd.casic.module.process.message.message.model.MessageDmNotice;
import cd.casic.module.process.message.message.model.MessageDmNoticeQuery;
import cd.casic.module.process.message.message.model.MessageNoticePatch;
import cd.casic.module.process.pipeline.definition.PipelineService;
import cd.casic.module.process.support.util.PipelineDataService;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @ClassName PipelineDataServiceImpl
 * @Author hopeli
 * @Date 2025/5/2 18:27
 * @Version 1.0
 */
@Service
public class PipelineDataServiceImpl implements PipelineDataService {

    @Resource
    PipelineService pipelineService;

    @Resource
    MessageDmNoticeService messageDmNoticeService;


    @Override
    public void cleanMessageData(){

        List<Pipeline> allPipeline = pipelineService.findAllPipelineNoQuery();

        for (Pipeline pipeline : allPipeline) {
            String domainId = pipeline.getId();

            MessageDmNoticeQuery messageDmNoticeQuery = new MessageDmNoticeQuery();
            messageDmNoticeQuery.setDomainId(domainId);
            List<MessageDmNotice> messageDmNoticeList =
                    messageDmNoticeService.findMessageDmNoticeList(messageDmNoticeQuery);

            if (!messageDmNoticeList.isEmpty()){
                continue;
            }

            // 克隆消息模版
            MessageNoticePatch messageNoticePatch = new MessageNoticePatch();
            messageNoticePatch.setDomainId(domainId);
            messageNoticePatch.setUserList(List.of(String.valueOf(pipeline.getAdminUserRespDTO().getId())));
            messageDmNoticeService.initMessageDmNotice(messageNoticePatch);
        }
    }
}
