package cd.casic.module.process.task.artifact.dataobject;

import cd.casic.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.springframework.data.annotation.Id;

import java.io.Serial;

/**
 * @ClassName TaskArtifactDo
 * @Author hopeli
 * @Date 2025/5/2 19:10
 * @Version 1.0
 */

@Data
@Builder
@Accessors(chain = true)
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@TableName(value = "pip_task_artifact", autoResultMap = true)
public class TaskArtifactDo extends BaseDO {

    @Serial
    private static final long serialVersionUID = -5333368911605592175L;

    @TableId
    private String taskId;

    private String artifactType;

    private String version;

    private String fileAddress;

    private String putAddress;

    private String authId;

    private String rule;

    private String dockerImage;
}
