package cd.casic.module.process.task.codescan.dataobject;

/**
 * @ClassName TaskArtifactXpackServiceImpl
 * @Author hopeli
 * @Date 2025/5/2 19:26
 * @Version 1.0
 */


import cd.casic.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.springframework.data.annotation.Id;

/**
 * 代码扫描
 * @author zcamy
 */

@Data
@Builder
@Accessors(chain = true)
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@TableName(value = "pip_task_code_scan", autoResultMap = true)
public class TaskCodeScanEntity extends BaseDO {

    @TableId
    private String taskId;

    private String projectName;

    private String authId;

    // 是否开启断言
    private String openAssert;

    // 是否启用调试模式
    private String openDebug;

    private String scanPath;

    // 扫描等级 min--最小，default--默认，max--最大
    private String scanGrade;

    // 扫描错误级别 default--默认 max--最大
    private String errGrade;

    // jdk版本
    private String toolJdk;

    // maven版本
    private String toolMaven;
}
