
package cd.casic.module.terminal.common;

import cn.orionsec.kit.lang.utils.Arrays1;
import jakarta.annotation.PostConstruct;
import cd.casic.module.terminal.common.annotation.Module;


/**
 * 操作类型初始化器
 *
 * @author Jiahang Li
 * @version 1.0.0
 * @since 2023/10/13 17:45
 */
public abstract class InitializingOperatorTypes implements OperatorTypeDefinition {

    @PostConstruct
    public void init() {
        // 获取模块注解
        Module moduleDefinition = this.getClass().getAnnotation(Module.class);
        if (moduleDefinition == null) {
            return;
        }
        // 获取类型
        OperatorType[] types = this.types();
        if (Arrays1.isEmpty(types)) {
            return;
        }
        // 定义类型
        String module = moduleDefinition.value();
        for (OperatorType type : types) {
            type.setModule(module);
            OperatorTypeHolder.set(type);
        }
    }

}
