package cd.casic.module.terminal.dal.dataobject;

import cd.casic.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.*;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.util.Date;

/**
 * 终端连接日志 实体对象
 *
 * @author Yuru Pu
 * @version 1.0
 * @since 2025/7/9 11:33
 */
@Data
@TableName(value = "terminal_connect_log", autoResultMap = true)
@KeySequence("terminal_connect_log_seq") // 用于 Oracle、PostgreSQL、Kingbase、DB2、H2 数据库的主键自增。如果是 MySQL 等数据库，可不写。
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = true)
public class TerminalConnectLogDO extends BaseDO {


    @TableId
    private Long id;

    @Schema(description = "用户id")
    @TableField("user_id")
    private Long userId;

    @Schema(description = "用户名")
    @TableField("username")
    private String username;

    @Schema(description = "主机id")
    @TableField("host_id")
    private Long hostId;

    @Schema(description = "主机名称")
    @TableField("host_name")
    private String hostName;

    @Schema(description = "主机地址")
    @TableField("host_address")
    private String hostAddress;

    @Schema(description = "类型")
    @TableField("type")
    private String type;

    @Schema(description = "sessionId")
    @TableField("session_id")
    private String sessionId;

    @Schema(description = "状态")
    @TableField("status")
    private String status;

    @Schema(description = "开始时间")
    @TableField("start_time")
    private Date startTime;

    @Schema(description = "结束时间")
    @TableField("end_time")
    private Date endTime;

    @Schema(description = "额外信息")
    @TableField("extra_info")
    private String extraInfo;

}
